checkRequire("Lua_ItemShowPanel");
checkRequire("Lua_ItemShowModelPanel");
Lua_ItemDetailWindow = class("Lua_ItemDetailWindow", Lua_Window);
function Lua_ItemDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ItemDetailWindow";
	self.layer = 4500;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_ItemDetailWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.maskBg:setAltas("common_atlas_1", "ui_common_zhezhao2");
end

function Lua_ItemDetailWindow:dispose()
	if self.itemShowPanel ~= nil then
		self.itemShowPanel:dispose();
		self.itemShowPanel = nil;
	end

	if self.modelShowPanel ~= nil then
		self.modelShowPanel:dispose();
		self.modelShowPanel = nil;
	end

	self:superCall("dispose");
end

function Lua_ItemDetailWindow:showWin(param)
	if param == nil or param.data == nil then
		self:hide();
		return;
	end

	if param.data.type == 8 and param.data.subType == Lua_PackTypeDefine.GATHERSOUL_ITEM then -- 灵魂
		if param.data.groove_id ~= nil and param.data.isShowUpgrade == nil then
			-- self.content.transform.localPosition = Vector3(-350, 0, 0);--  -25
			LuaUtil.setObjPos(self.content, -350, 0, 0);
		else
			-- self.content.transform.localPosition = Vector3(162, 0, 0);
			LuaUtil.setObjPos(self.content, 162, 0, 0);
		end
	elseif param.data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM and param.data.type == 13 then -- 军装
		-- self.content.transform.localPosition = Vector3(0, 260, 0);
		LuaUtil.setObjPos(self.content, 0, 260, 0);
	else
		-- self.content.transform.localPosition = Vector3(0, 0, 0);
		LuaUtil.setObjPos(self.content, 0, 0, 0);
	end

	-- 道具信息
	if self.itemShowPanel == nil then
		if param.data.subType == Lua_PackTypeDefine.CARD_ITEM and param.data.type == 11 then -- 卡牌
			self.itemShowPanel = Lua_ItemShowPanel.new(self.content,1);
		elseif param.data.subType == Lua_PackTypeDefine.STAMP_ITEM and param.data.type == 12 and param.data.stamp_type ~= 0 then -- 魂印
			self.itemShowPanel = Lua_ItemShowPanel.new(self.content,2);
		elseif param.data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM and param.data.type == 13 then -- 军装
			self.itemShowPanel = Lua_ItemShowPanel.new(self.content,3);
		else
			self.itemShowPanel = Lua_ItemShowPanel.new(self.content);
		end
	end
	self.itemShowPanel:setShowData(param);

	if param.data.type == 12 and param.data.subType == Lua_PackTypeDefine.STAMP_ITEM and param.data.stamp_type ~= 0 and param.data.isStamp == nil then
		local vo = DataCenter.stampData:getArrByStampInfo(param.data.part);
		if vo ~= nil then
			if self.leftShowPanel == nil then
				self.leftShowPanel = Lua_ItemShowPanel.new(self.content,2);
			end
			self.leftShowPanel:setShowData( { data = vo.stampVo, isShowBtns = false });
			self.leftShowPanel:setLocation(-216, 0, 0);
			self.itemShowPanel:setLocation(216, 0, 0);
			return;
		end
	end

	-- 不显示左侧自身的对比信息
	if self.leftShowPanel ~= nil then
		self.leftShowPanel:dispose();
		self.leftShowPanel = nil;
	end

	-- 展示模型
	local vo = param.data;
	if vo.config ~= nil and vo.config.tipShowModel ~= nil and vo.config.tipShowModel ~= "" then
		if self.modelShowPanel == nil then
			self.modelShowPanel = Lua_ItemShowModelPanel.new(self.content, 348, 439, 0, 200);
		end
		self.modelShowPanel:setShowData(vo);
		self.modelShowPanel:setLocation(-180, 0, 0);
		self.itemShowPanel:setLocation(180, 0, 0);
	else
		if self.modelShowPanel ~= nil then
			self.modelShowPanel:dispose();
			self.modelShowPanel = nil;
		end
		self.itemShowPanel:setLocation(0, 0, 0);
	end
end