checkRequire("Lua_EquipShowPanel");
checkRequire("Lua_ItemShowModelPanel");
Lua_ItemEquDetailWindow = class("Lua_ItemEquDetailWindow", Lua_Window);
function Lua_ItemEquDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ItemEquDetailWindow";
	self.layer = 4500;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_ItemEquDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.maskBg:setAltas("common_atlas_1", "ui_common_zhezhao2");
end

function Lua_ItemEquDetailWindow:showWin(param)
	if param == nil or param.data == nil then
		self:hide();
		return;
	end

	-- 装备信息
	if self.rightShowPanel == nil then
		self.rightShowPanel = Lua_EquipShowPanel.new(self.content);
	end
	self.rightShowPanel:setShowData(param);

	-- 对比身上的装备
	local vo = param.data;
	if vo.type == 1
		and vo.subType ~= Lua_PackTypeDefine.SHENSHOU_EQU
		and vo.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE
		and vo.subType ~= Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM
		and vo.packType ~= Lua_PackData.EQU_PACK then
		local eq = DataCenter.equData:getEquByPart(vo.part);
		if eq ~= nil then
			if self.leftShowPanel == nil then
				self.leftShowPanel = Lua_EquipShowPanel.new(self.content);
			end
			self.leftShowPanel:setShowData( { data = eq, isShowBtns = false });
			self.leftShowPanel:setLocation(-225, 0, 0);
			self.rightShowPanel:setLocation(225, 0, 0);
			return;
		end
	end
    
	-- 神兽装备对比
	if vo.type == 1
		and vo.subType == Lua_PackTypeDefine.SHENSHOU_EQU
		and vo.packType == Lua_PackData.SACRED_ANIMAL_BAG then
		local eq = DataCenter.sacredAnimalData:getAnimalEquipByPart(vo.part);
		if eq ~= nil then
			if self.leftShowPanel == nil then
				self.leftShowPanel = Lua_EquipShowPanel.new(self.content);
			end
			self.leftShowPanel:setShowData({ data = eq, isShowBtns = false });
			self.leftShowPanel:setLocation(-225, 0, 0);
			self.rightShowPanel:setLocation(225, 0, 0);
			return;
		end
	end

	-- 翅膀对比已装备的翅膀
	if vo.subType == Lua_PackTypeDefine.WING_ITEM and DataCenter.GodWingData.wear_wing_id ~= nil and DataCenter.GodWingData.wear_wing_id ~= 0 then
		local equWing = Lua_ToolVo.createToolVo(DataCenter.GodWingData.wear_wing_id, 1, 1);
		equWing.wingColor = DataCenter.GodWingData.wear_wing_color;
		equWing.wingAttr = DataCenter.GodWingData.attributes;
		equWing.packType = Lua_PackData.EQU_PACK;
		if self.leftShowPanel == nil then
			self.leftShowPanel = Lua_EquipShowPanel.new(self.content);
		end
		self.leftShowPanel:setShowData({ data = equWing, isShowBtns = false });
		self.leftShowPanel:setLocation(-216, 0, 0);
		self.rightShowPanel:setLocation(216, 0, 0);
		return;
	end

	-- 不显示左侧自身的对比信息
	if self.leftShowPanel ~= nil then
		self.leftShowPanel:dispose();
		self.leftShowPanel = nil;
	end

	-- 展示模型
	if vo.config ~= nil and vo.config.tipShowModel ~= nil and vo.config.tipShowModel ~= "" then
		if self.modelShowPanel == nil then
			self.modelShowPanel = Lua_ItemShowModelPanel.new(self.content, 426, 599);
		end
		self.modelShowPanel:setShowData(vo);
		self.modelShowPanel:setLocation(-216, 0, 0);
		self.rightShowPanel:setLocation(216, 0, 0);
		return;
	else
		if self.modelShowPanel ~= nil then
			self.modelShowPanel:dispose();
			self.modelShowPanel = nil;
		end
	end
	self.rightShowPanel:setLocation(0, 0, 0);
end

function Lua_ItemEquDetailWindow:dispose()
	self:superCall("dispose");
end