checkRequire("Lua_ItemEquDetail");
Lua_ItemTwoEquDetailWindow = class("Lua_ItemTwoEquDetailWindow", Lua_Window);
function Lua_ItemTwoEquDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ItemTwoEquDetailWindow";
	self.skinName = "ItemTwoEquDetailWindow_skin";
	self.layer = 4500;
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_ItemTwoEquDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.bg1.clickScale = false;
	self.bg2.clickScale = false;
	self.bg1:addClickFuntion(self, self.onBgClick);
	self.bg2:addClickFuntion(self, self.onBgClick);

	self.equItem1 = Lua_ItemEquDetail.new(self.content);
	self.equItem1:setLocation(-223, 0, 0);

	self.equItem2 = Lua_ItemEquDetail.new(self.content);
	self.equItem2:setLocation(223, 0, 0);
end

function Lua_ItemTwoEquDetailWindow:showWin(param)
	if self.data ~= nil then
		return;
	end
	self.data = param[2];
	
	self.equItem1:setData(param[1]);
	self.equItem2:setData(self.data);
	
	local oo;
	if param[3] == true then
		oo = Lua_PackUtil.showMarketSellDetail(self.data);
	elseif DataCenter.packData.showWharePanel == false then
		oo = Lua_PackUtil.showNormalDetail(self.data);
	else
		oo = Lua_PackUtil.showWhareDetail(self.data);
	end
	self.actList = oo[2];
	
	-- 帮派仓库显示捐献积分
	if self.actList:indexOf(11) ~= -1 then
		self.equItem1:showHideLeagueScore(true, true);
		self.equItem2:showHideLeagueScore(true, true);
	elseif self.actList:indexOf(10) ~= -1 then
		-- 帮派仓库兑换装备，要显示兑换积分
		self.equItem1:showHideLeagueScore(true, false);
		self.equItem2:showHideLeagueScore(true, false);
	else
		self.equItem1:showHideLeagueScore(false, false);
		self.equItem2:showHideLeagueScore(false, false);
	end

	if param[4] == true then
		local btnNames = oo[1];
		if btnNames ~= nil and btnNames:getSize() > 0 then
			self.btnList = Lua_ButtonList.new(self.content, btnNames, 57, self, self.onButtonListClick,
				"tab1_souchong_normal", "tab1_souchong_select", Vector4(0, 0, 130, 50), Vector4(0, 0, 130, 50),
				Lua_ColorDefine.transColor("192e41"), Lua_ColorDefine.transColor("883a0b"), Vector4(24, 26, 120, 30), 1);
			self.btnList:setLocation(499, -274 + 57 * (btnNames:getSize() - 1), 0);
		end	
	else
		if self.btnList ~= nil then
			self.btnList:dispose();
			self.btnList = nil;
		end
	end
	-- Lua_MsgUtil.callFunc("SHILED_BOSS_UI_AVATAR",true);
end

function Lua_ItemTwoEquDetailWindow:onButtonListClick(val)
	local actVal = self.actList[val];
	if actVal ~= nil then
		Lua_PackUtil.doActClick(actVal, self.data);
	end
	self:hide();
end

function Lua_ItemTwoEquDetailWindow:hide()
	self:superCall("hide");
	-- Lua_MsgUtil.callFunc("SHILED_BOSS_UI_AVATAR", false);
end