-- 姻缘-婚姻戒指道具tips界面
checkRequire("Lua_MarryUtil");
Lua_LoveGiftTipsWindow = class("Lua_LoveGiftTipsWindow", Lua_Window);
function Lua_LoveGiftTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LoveGiftTipsWindow";
	self.skinName = "LoveGiftTipsWindow_skin";
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_LoveGiftTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.attDragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 324, 160));
	self.attDragContainer:setLocation(-1, -73, 0);
	self.draggableAttPanel = Lua_attDragPanel.new(self.attDragContainer.sub);
	self.attDragContainer:addSubContainer(self.draggableAttPanel, false);

	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onBgClick);

	self.img = Lua_ToolImage.new(self.content);
	self.img:setLocation(-107, 140, 0);
	self.img:setCanClick(false);
end

function Lua_LoveGiftTipsWindow:showWin(param)
	self.data = param.data;

	local keepsakeInfo = DataCenter.marryData.keepsake_info;
	if param.isShowBtn then
		self.upBg:addClickFuntion(self, self.onUpBgClick);
	end
	self.upObj:SetActive(param.isShowBtn);

	local bgStrDic = {"ui_common_tips_02_lv","ui_common_tips_02_lan","ui_common_tips_02_zi","ui_common_tips_02_huang","ui_common_tips_02_hong","ui_common_tips_02_fenhong"};
	self.topBg:setAltas("common_atlas_1", bgStrDic[self.data.color]);

	self.img.data = self.data;
	self.nameTxt.text = self.data.colorName;
	self.useLvTxt.text = LanUtil.formateStr(LanUtil.getValue(124162), tostring(self.data.useLvl));

	local id;
	local config;
	if param.data.bInitLoveGiftAtt == nil or param.data.bInitLoveGiftAtt == false then
		id = (keepsakeInfo.keepsake_id % 10) * 1000 + keepsakeInfo.keepsake_lvl;
		if keepsakeInfo.wedding_state == 1 then
			self.roleTxt2.text = LanUtil.formateStr(LanUtil.getValue(124161), tostring(DataCenter.roleData.name), tostring(DataCenter.marryData.Married_partner_name));
			self.desTxt.text = "[" .. Lua_ColorDefine.BLUE_STR .. "]" .. LanUtil.getValue(124165);
			self.img.data = Lua_ToolVo.new(keepsakeInfo.keepsake_id,1,1);
		else
			self:initAtt();
		end

		if keepsakeInfo.keepsake_lvl ~= 0 then 
			self.upLvlTxt.text = "+"..keepsakeInfo.keepsake_lvl;
		else
			self.upLvlTxt.uiwidget.gameObject:SetActive(false);
		end

		config = Lua_MarryUtil.getMarryPledge(id + 1) == nil and Lua_MarryUtil.getMarryPledge(id) or Lua_MarryUtil.getMarryPledge(id + 1);
		if keepsakeInfo.keepsake_lvl ~= config.max_level then
			self.expTxt.text = (Lua_CommonUtil.getNumberTrans(keepsakeInfo.keepsake_exp) .. "/" .. Lua_CommonUtil.getNumberTrans(config.need_exp));
		else
			self.expTxt.text = (Lua_CommonUtil.getNumberTrans(config.need_exp) .. "/" .. Lua_CommonUtil.getNumberTrans(config.need_exp));
		end
	else
		self.upLvlTxt:setEnable(false);

		id = (self.data.id % 10) * 1000;
		config = Lua_MarryUtil.getMarryPledge(id + 1);
		self.expTxt.text = (Lua_CommonUtil.getNumberTrans(0) .. "/" .. Lua_CommonUtil.getNumberTrans(config.need_exp));
		self:initAtt();
	end

	local param;
	local totalFight = 0;
	for k,v in ipairs(Lua_ThingDefine.params) do
		param = Lua_MarryUtil.getAttConfig(id, v);
		if param ~= nil and param ~= 0 then
			totalFight = totalFight + Lua_FightUtil.caculateConfigForce({v = param});
		end
	end
	self.fightTxt.text = totalFight;
	self.draggableAttPanel:setText(self.data,id);
	self.attDragContainer:updateChildPos();
end

function Lua_LoveGiftTipsWindow:initAtt()
	self.desTxt.text = "[" .. Lua_ColorDefine.GOLD_STR .. "]" .. self.data.des;

	self.roleTxt2:setEnable(false);
	self.roleTxt1:setEnable(false);
end

function Lua_LoveGiftTipsWindow:onBgClick(go)
end

function Lua_LoveGiftTipsWindow:onUpBgClick()
	Lua_WindowUtil.openWin("Lua_MailBoxWindow", WinParam.ACTION_OPEN, 2);
	self:hide();
end

function Lua_LoveGiftTipsWindow:dispose()
	if self.attDragContainer ~= nil then
		self.attDragContainer:dispose();
		self.attDragContainer = nil;
	end
	if self.draggableAttPanel ~= nil then
		self.draggableAttPanel:dispose();
		self.draggableAttPanel = nil;
	end
	if self.img ~= nil then
		self.img:dispose();
		self.img = nil;
	end
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_attDragPanel = class("Lua_attDragPanel", Lua_DragContainerItem);
function Lua_attDragPanel:ctor(sub)
	self:superCall("ctor", sub, nil);
end

function Lua_attDragPanel:buildShowItem()
	self:superCall("buildShowItem");

	self._height = 0;
end
function Lua_attDragPanel:setText(data, id)
	self.data = data;
	self.id = id;

	local item;
	self._height = 0;
	local isHave = false;
	for k,v in ipairs(Lua_ThingDefine.params) do
		local obj = Lua_MarryUtil.getAttConfig(id, v);
		if obj ~= nil and obj ~= 0 then
			item = Lua_attTxtItem.new(self.content);
			item:setText(v, obj);
			item:setLocation(0, -self._height, 0);
			self._height = self._height + item:getHeight() + 8;
			isHave = true;
		end
	end

	if isHave == false then
		self.attTxt = UICreate.createLabel(self.content, "", -162, -69, 100, 22, 22);
		self.attTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		self.attTxt:setDepth(3);
		self.attTxt.text = "[00E125]"..LanUtil.getValue(124147) .. "[-]"
	end
end

function Lua_attDragPanel:updateSubPos()
	self.dragContainer:updateSubPos(0, 0, 0);
end

function Lua_attDragPanel:getHeight()
	return self._height;
end





--------------------------------------------------





Lua_attTxtItem = class("Lua_attTxtItem", Lua_DisplayObject)
function Lua_attTxtItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_attTxtItem:buildShowItem()
	self:superCall("buildShowItem");

	self.attTxt = UICreate.createLabel(self.content, "", -162, 69, 324, 0, 22);
	self.attTxt.pivot = UIWidget.Pivot.Left;
	self.attTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.attTxt:setDepth(3);
end

function Lua_attTxtItem:setText(paramStr,val)
	self.attTxt.text = "[85A8BE]"..Lua_ThingDefine.getParamName(paramStr).."：".."[-]".."[00E125]"..val.."[-]";
end

function Lua_attTxtItem:getHeight()
	return self.attTxt.height;
end