-- 新获得的可使用的道具tips
Lua_NewItemTipWindow = class("Lua_NewItemTipWindow", Lua_Window);
function Lua_NewItemTipWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NewItemTipWindow";
	self.skinName = "NewItemTipWindow_skin";
	self.layer = 500;
	self.isModel = false;
end

function Lua_NewItemTipWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIndexList = Array();
	self.startTime = 0;
	self.showingIndex = -1;
	self.autoCloseCount = 0;
	self.bRegistTimer = false;

	LuaUtil.setObjPos(self.content, MainWinDefine.V_width / 2 - 295, -MainWinDefine.V_height / 2 + 220, 0);

	self.subBtn:addClickFuntion(self, self.onSubClick);

	self:addLuaEvent("PACK_UPDATE", self, self.onPackUpdate);
	self:addLuaEvent("USE_PACK_GIFT", self, self.onUsePackGift);
end

function Lua_NewItemTipWindow:showWin(param)
	if param == self.showingIndex then
		self:updateCurData();
	else
		for i = 1, self.itemIndexList:getSize() do
			if self.itemIndexList[i] == param then
				return;
			end
		end

		local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		local curData = bagData:getItemByIndex(param);
		local isAdd = false;
		if curData ~= nil and curData.type == 1 then
			local citem = bagData:getItemByIndex(self.showingIndex);
			if citem ~= nil and curData.type == 1 and citem.part == curData.part then
				if curData.force > citem.force then
					self.showingIndex = param;
					self.startTime = 0;
					self:updateCurData();
				end
				isAdd = true;
			end

			if isAdd == false then
				local targetItem;
				for i = 1, self.itemIndexList:getSize() do
					targetItem = bagData:getItemByIndex(self.itemIndexList[i]);
					if targetItem ~= nil then
						if targetItem.part == curData.part then
							if curData.force > targetItem.force then
								self.itemIndexList[i] = param;
							end
							isAdd = true;
							break;
						end
					end
				end
			end
		end

		if isAdd == false then
			self.itemIndexList:add(param);
		end
		if self.showingIndex == -1 then
			self:hide();
		end
	end
end

function Lua_NewItemTipWindow:hide()
	if self.itemIndexList:getSize() ~= 0 then
		self.startShowTime = getTime();
		self.showingIndex = self.itemIndexList[1];
		self.itemIndexList:remove(1);
		self.startTime = 0;
		self:updateCurData();
	else
		self:superCall("hide");
	end
end

function Lua_NewItemTipWindow:onPackUpdate(go)
	self:updateCurData();
end

function Lua_NewItemTipWindow:onUsePackGift(data)
	self.data = data;

	local vo = Lua_ToolVo.new(data.need_money[1], data.need_money[2])
	if self.amount == nil then
		self.amount = 1;
	end
	self.totalMoney = data.need_money[2] * self.amount;
	self.moneyType = data.need_money[1];

	local tipData = {};
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.onEnSureClickCallBack;
	tipData.rewardArr = Lua_RewardsUtil.getRewardList(self.data.effect_prop.reward_id).rewardsVoArr;
	tipData.des = LanUtil.formateStr(LanUtil.getValue(123802), tostring(self.totalMoney), vo.name);
	Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, tipData);
end

function Lua_NewItemTipWindow:onEnSureClickCallBack(data)
	DataCenter.moneyData:isMoneyEnough(self.moneyType, self.totalMoney, false, true);
	local msg = ProtoPublic_pb.Proto11400106();
	msg.index = self.data.index;
	if self.amount ~= nil then
		msg.amount = self.amount;
	else
		msg.amount = 1;
	end
	if self.reward_index ~= nil then
		msg.reward_index = self.reward_index
	end
	sendMsg(11400106, msg);
end

function Lua_NewItemTipWindow:updateCurData()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local curData = bagData:getItemByIndex(self.showingIndex);
	if curData == nil then
		self:hide();
		return;
	end

	if curData.type == 1 then
		if (curData.career == 0 or curData.career == DataCenter.roleData.career) and
			curData.profession <= DataCenter.roleData.profession then
			local equData = DataCenter.equData;
			local myEqu = equData:getEquByPart(curData.part);
			if myEqu ~= nil and curData.force <= myEqu.force then
				self:hide();
				return;
			end
		else
			self:hide();
			return;
		end
	end

	-- 2018.06.13 到达500级或之后，移除倒计时和自动使用效果，玩家不进行操作，除非下线、点击使用或关闭按钮
	if DataCenter.roleData.level < Lua_CommonUtil.getCommonConfig("no_auto_use_level", 1) then
		self:startTimer();
	else
		self:endTimer();
	end

	if self.startTime == 0 then
		self.startTime = getTime();

		if self.itemImage == nil then
			self.itemImage = Lua_ToolImage.new(self.content);
			self.itemImage:setDepth(4);
			self.itemImage:setLocation(0, 49, 0);
		end
		self.itemImage.data = curData;
		self.itemImage:showNewTip(false);
		
		self.itemTxt.text = curData.colorName;
		self:onCheckNewItemTime(0);
	end
end

function Lua_NewItemTipWindow:startTimer()
	if self.bRegistTimer ~= true then
		self.bRegistTimer = true;
		Lua_CommonUtil.addTimer("newItem", 0.5, self, self.onCheckNewItemTime);
	end
end

function Lua_NewItemTipWindow:onCheckNewItemTime()
	if self.showingIndex == -1 then
		return;
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local curData = bagData:getItemByIndex(self.showingIndex);
	if curData == nil then
		return;
	end

	local leftTime = 9 -(getTime() - self.startTime);
	if leftTime <= 0 then
		self.autoCloseCount = 1 + self.autoCloseCount;
		if self.autoCloseCount >= 3 then
			self.itemIndexList:clear();
		end

		-- self:hide();
		-- 2018.5.5策划要改成倒计时完后自动穿戴
		-- if DataCenter.roleData.level < Lua_CommonUtil.getCommonConfig("no_auto_use_level", 1) then
		--     self:onSubClick(nil);
		-- else
		--     self:hide();
		-- end
		if self.bRegistTimer then
			self:onSubClick(nil);
		end
	end

	local str;
	if math.floor(leftTime) > 0 and self.bRegistTimer == true then
		if curData.type == 1 or curData.type == 10 then
			str = LanUtil.getValue(110812) .. "(" .. tostring(math.floor(leftTime)) .. ")";
		else
			str = LanUtil.getValue(110822) .. "(" .. tostring(math.floor(leftTime)) .. ")";
		end
	else
		if curData.type == 1 or curData.type == 10 then
			str = LanUtil.getValue(110812);
		else
			str = LanUtil.getValue(110822);
		end
	end
	self.subBtn.label = str;
end

function Lua_NewItemTipWindow:onSubClick(go)
	self.autoCloseCount = 0;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local curData = bagData:getItemByIndex(self.showingIndex);
	if curData.type == 1 then
		Lua_PackUtil.equItem(curData)
	elseif curData.type == 10 then
		Lua_PackUtil.putOnFairy(curData)
	elseif curData.type == 6 then
		Lua_PackUtil.useGIFT(curData);
	elseif curData.type == 1023 then
		Lua_PackUtil.useGIFT(curData);
	elseif curData.type == 3 and curData.subType == Lua_PackTypeDefine.WING_ITEM then
		Lua_PackUtil.putOnWing(curData);
	elseif curData.type == Lua_PackTypeDefine.GSBACKGIFT_TYPE then
	-- 使用后台福利礼包特殊处理
		Lua_PackUtil.useGIFT(curData);
	else
		if curData.effect_prop.name == "hook_time" then
			if DataCenter.funcOpenData:isOpened(10030) == false then
				local tipsStr = getConfig({"func_open", 10030, "advance_message"});
				if tipsStr ~= nil then
					OperateAlert.show(tipsStr);
				end
				return;
			end
			Lua_WindowUtil.openWin("Lua_OutLineAddWindow", WinParam.ACTION_OPEN, curData);
		else
			Lua_PackUtil.useItem(curData, nil)
		end
	end
	self:hide();
end

function Lua_NewItemTipWindow:endTimer()
	if self.bRegistTimer == true then
		self.bRegistTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onCheckNewItemTime);
	end
end

function Lua_NewItemTipWindow:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end