Lua_OutputWindow = class("Lua_OutputWindow", Lua_Window);
function Lua_OutputWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_OutputWindow";
	self.skinName = "OutputWindow_skin";
	self.showClose = false;
	self.isClickClose = true;
	self.blackAlpha = 0.5;
end

function Lua_OutputWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_OutputWindow:showWin(param)
	self.outid = param;
	self:updateInfo();
end

function Lua_OutputWindow:updateInfo()
	self.infoTxt.text = getConfig({"equ_output", self.outid, "con_map"});

	local list = getConfig({"equ_output", self.outid, "icon_list"});
	local offsetX = -1 * 90 * #list / 2 + 45;
	local offsetY = -87;
	local icon;
	self.iconList = Array();
	for i = 1, #list do
		icon = Lua_OutputIcon.new(self.content);
		icon:setData(list[i]);
		icon:setLocation(offsetX + (i - 1) * 90, offsetY, 0);
		self.iconList:add(icon);
	end
end

function Lua_OutputWindow:dispose()
	if self.iconList ~= nil then
		self.iconList:dispose();
		self.iconList:clear();
		self.iconList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_OutputIcon = class("Lua_OutputIcon", Lua_DisplayObject);
function Lua_OutputIcon:ctor(p)
	self:superCall("ctor", p);
end

function Lua_OutputIcon:buildShowItem()
	self:superCall("buildShowItem");

	self.iconBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_icon_gntb", 0, 0, 0, 0);
	self.iconBg.name = "iconBg";
	self.iconBg.depth = 5;

	self.icon = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0, 0);
	self.icon.name = "icon";
	self.icon.depth = 6;
	self.icon:addClickFuntion(self,self.onIconClick)
end

function Lua_OutputIcon:setData(val)
	self.data = val;
	self.icon:setAltas(val.atlas,val.icon);
end

function Lua_OutputIcon:onIconClick(g)
	if self.data.openId ~= nil then
		if DataCenter.funcOpenData:isOpened(self.data.openId, true) == false then
			return;
		end
	end
	
	if type(self.data.win) == "string" then
		Lua_WindowUtil.openWin(self.data.win, nil, nil);
	else
		local itemID;
		if self.data.win[1].winName == "Lua_ShopWindow" and self.data.win[1].itemID ~= nil then
			if type(self.data.win[1].itemID) == "table" then
				itemID = self.data.win[1].itemID[DataCenter.roleData.career];
			elseif type(self.data.win[1].itemID) == "number" then
				itemID = self.data.win[1].itemID;
			end
		end
		Lua_PackUtil.openWinByList(self.data.win, nil, nil, false, itemID);
	end
	Lua_WindowUtil.openWin("Lua_OutputWindow", WinParam.ACTION_CLOSE);
end

function Lua_OutputWindow:dispose()
	if self.icon ~= nil then
		self.icon:dispose();
		self.icon = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end