﻿Lua_SelectedGiftItemWindow = class("Lua_SelectedGiftItemWindow", Lua_Window);
function Lua_SelectedGiftItemWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SelectedGiftItemWindow";
	self.skinName = "SelectedGiftItemWindow_skin";
end

function Lua_SelectedGiftItemWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.Count = 1;
	self.numArr = Array();

	self:addLuaEvent("SELECTED_GIFT_CLICK", self, self.onGiftClick)

	self.minus:addClickFuntion(self, self.onMinusIconClick);
	self.plus:addClickFuntion(self, self.onPlusIconClick);
	self.countBg:addClickFuntion(self, self.onCountBgClick);
	self.ensureBtn:addClickFuntion(self, self.onEnSureClick);

	self.showData = Lua_WindowUtil.getWinData("Lua_SelectedGiftItemWindow", true);
	self.giftName.text = self.showData.colorName;
	self.countLbl.text = LanUtil.formateStr(LanUtil.getValue(123800), tostring(self.showData.count));
	self.selectLbl.text = LanUtil.getValue(123801);
	self.costLbl:setEnable(self.showData.need_money ~= nil or self.showData.need_item ~= nil);

	local itemArr = Lua_RewardsUtil.getRewardList(self.showData.effect_prop.reward_id).rewardsVoArr;
	local len = itemArr:getSize();
	self.Arr = Array();
	for i = 1, len do
		self.Arr:add({index = i, selected = false, vo = itemArr[i]});
	end
	self.item_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 435, 174));
	self.item_DragList:setLocation(0, 9, 0);
	self.item_DragList:setListCell(Lua_GiftPackItem, 87, 87, 5);
	self.item_DragList:setLuaArrayData(self:minePackSellGoodsArr(self.Arr), false);

	self:onLblChange();
	self:costShow();
end

function Lua_SelectedGiftItemWindow:costShow()
	if self.showData.need_money ~= nil then
		local vo = Lua_ToolVo.new(self.showData.need_money[1]);
		local costNum = self.showData.need_money[2] * self.Count;
		self.costLbl.text = LanUtil.formateStr(LanUtil.getValue(123803), tostring(costNum), tostring(vo.name))
	elseif self.showData.need_item ~= nil then
		local vo = Lua_ToolVo.new(self.showData.need_item[1]);
		local costNum = self.showData.need_item[2] * self.Count;
		self.costLbl.text = LanUtil.formateStr(LanUtil.getValue(123804), tostring(vo.name), tostring(costNum))
	end
end

function Lua_SelectedGiftItemWindow:minePackSellGoodsArr(arr)
	local len = arr:getSize();
	local num = 0;
	if len < 10 then
		num = 10 - len;
	elseif len % 5 > 0 then
		num = 5 -(len % 5);
	end

	for i = 1, num do
		arr:add(i);
	end
	return arr;
end

function Lua_SelectedGiftItemWindow:onCountBgClick()
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, {callBackOwner = self, callBack = self.onCountInputCallBack, pox = 0, poy = -16})
end

function Lua_SelectedGiftItemWindow:onCountInputCallBack(data)
	if data.state == 3 then
		self.Count = data.num
	elseif data.state == 1 then
		self.count.text = ""
		self.numArr:add(data.num);
		for i = 1, self.numArr:getSize() do
			self.count.text = self.count.text .. self.numArr[i]
		end
		self.Count = tonumber(self.count.text)
	elseif data.state == 0 then
		self.numArr:clear();
		self.Count = 1
	end

	if data.state == 2 then
		self.numArr:clear();
	end
	self:checkRange();
	self:onLblChange();
	self:costShow();
end

function Lua_SelectedGiftItemWindow:checkRange()
	if self.Count >= self.showData.count then
		self.Count = self.showData.count
	elseif self.Count < 1 then
		self.Count = 1
	else
		self.Count = self.Count
	end
end

function Lua_SelectedGiftItemWindow:onMinusIconClick()
	if self.Count <= 1 then
		self.Count = 1
	else
		self.Count = self.Count - 1
	end
	self:onLblChange();
	self:costShow();
end

function Lua_SelectedGiftItemWindow:onPlusIconClick()
	if self.Count >= self.showData.count then
		self.Count = self.showData.count
	else
		self.Count = self.Count + 1
	end
	self:onLblChange();
	self:costShow();
end

function Lua_SelectedGiftItemWindow:onLblChange()
	self.count.text = self.Count;
end

function Lua_SelectedGiftItemWindow:onEnSureClick()
	if self.itemIndex == nil then
		OperateAlert.show(LanUtil.getValue(123801));
		return;
	end

	local msg = ProtoPublic_pb.Proto11400106();
	msg.index = self.showData.index;
	msg.amount = self.Count;
	msg.reward_index = self.itemIndex;
	sendMsg(11400106, msg);
	self:hide();
end

function Lua_SelectedGiftItemWindow:onGiftClick(data)
	for i = 1, self.Arr:getSize() do
		if self.Arr[i] == data then
			self.Arr[i].selected = true;
		else
			if type(self.Arr[i]) ~= "number" then
				self.Arr[i].selected = false;
			end
		end
	end
	self.itemIndex = data.index;
	self.item_DragList:setLuaArrayData(self.Arr, false);
end

function Lua_SelectedGiftItemWindow:dispose()
	if self.item_DragList ~= nil then
		self.item_DragList:dispose();
		self.item_DragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_GiftPackItem = class("Lua_GiftPackItem", Lua_ListCell);
function Lua_GiftPackItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GiftPackItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(false);

	self.tickImg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xz", 0, 0, 0, 0);
	self.tickImg:setDepth(7);
	self.tickImg:setEnable(false);
end

function Lua_GiftPackItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if type(data) == "number" then
		self.itemImg.data = nil;
		self.tickImg:setEnable(false);
	else
		self.itemImg.data = data.vo;
		self.tickImg:setEnable(self.data.selected);
	end
end

function Lua_GiftPackItem:onPlayerSoundClick()
	if type(self.data) ~= "number" then
		Lua_MsgUtil.callFunc("SELECTED_GIFT_CLICK", self.data);
		Lua_PackUtil.showItemInfo(self.data.vo, nil, false);
	end
end

function Lua_GiftPackItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.tickImg ~= nil then
		self.tickImg:dispose();
		self.tickImg = nil;
	end

	self:superCall("dispose");
end