-- 装备tips信息显示
checkRequire("Lua_ItemEquDetail");
Lua_EquipShowPanel = class("Lua_EquipShowPanel", Lua_DisplayObject);
function Lua_EquipShowPanel:ctor(p)
	self:superCall("ctor", p, "ItemEquDetailWindow_skin");
end

function Lua_EquipShowPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_EquipShowPanel";

	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onBgClick);

	self.equItem = Lua_ItemEquDetail.new(self.content);
end

function Lua_EquipShowPanel:onBgClick(go)
end

function Lua_EquipShowPanel:setShowData(obj)
	if obj == nil then
		return;
	end

	self.data = obj.data;
	self.isMarketSell = obj.isMarketSell;
	self.isShowBtns = obj.isShowBtns;
	self.equItem:setData(self.data, obj.equLvlMark);

	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end

	if WindowMananger.getInstance():isWindowShowing("Lua_ForgingWindow") == false then
		self.actList = nil;
		local oo = nil;
		if self.isMarketSell == true then
			-- 市场上架
			oo = Lua_PackUtil.showMarketSellDetail(self.data);
		elseif DataCenter.packData.showWharePanel == false then
			oo = Lua_PackUtil.showNormalDetail(self.data);
		else
			oo = Lua_PackUtil.showWhareDetail(self.data);
		end
		self.actList = oo[2];

		if self.actList:indexOf(11) ~= -1 then
			-- 帮派仓库显示捐献积分
			self.equItem:showHideLeagueScore(true, true);
		elseif self.actList:indexOf(10) ~= -1 then
			-- 帮派仓库兑换装备，要显示兑换积分
			self.equItem:showHideLeagueScore(true, false);
		else
			self.equItem:showHideLeagueScore(false, false);
		end

		if self.isShowBtns == true and self.data.isShowBtn == nil then  -- 骑装合成做了标识处理，请勿改动
			local btnNames = oo[1];
			if btnNames ~= nil and btnNames:getSize() > 0 then
				self.btnList = Lua_ButtonList.new(self.content, btnNames, 57, self, self.onButtonListClick,
					"ui_common_btn_x9", "ui_common_btn_x8", Vector4(0, 0, 120, 42), Vector4(0, 0, 120, 42),
					Lua_ColorDefine.transColor("B7E8FF"), Lua_ColorDefine.transColor("FFFCB7"), Vector4(22, 22, 120, 30),
					1, "common_atlas_1", Vector3(0, 0, 0), Vector3(0, 0, 0));
				self.btnList:setLocation(285, -264 + 57 *(btnNames:getSize() -1), 0);
			end

			if self.data.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then -- 骑装
				if self.data.packType ~= Lua_PackData.BAG_PACK and self.data.mountPart ~= nil then
					self.btnList:setRedDotPos(55,16);
					local vo = DataCenter.mountEquipData:getArrByPartData(self.data.mountPart);
					if vo.isShowIconRed == true then--强化红点
						self.btnList:setRedDotStateByIndex(1,true);
					end

					if vo.isShowRedDot == true and vo.item_id ~= 0 then -- 替换红点
						self.btnList:setRedDotStateByIndex(3,true);
					end
				end
			end
		end
	else
		self.equItem:showHideLeagueScore(false, false);
	end
end

function Lua_EquipShowPanel:onButtonListClick(val)
	local actVal = self.actList[val];
	if actVal ~= nil then
		Lua_PackUtil.doActClick(actVal, self.data)
	end
	Lua_WindowUtil.openWin("Lua_ItemEquDetailWindow", WinParam.ACTION_CLOSE)
end