-- 锻造-套装淬炼
Lua_ItemCuiLianDetail = class("Lua_ItemCuiLianDetail", Lua_DragContainerItem);
function Lua_ItemCuiLianDetail:ctor(p)
	self:superCall("ctor", p, "ItemCuiLianDetail_skin");
end

function Lua_ItemCuiLianDetail:buildShowItem()
	self:superCall("buildShowItem");
	
	self.itemArr = Array();
end

function Lua_ItemCuiLianDetail:setData(data)
	if data == nil then
		return;
	end

	if self.itemArr:getSize() > 0 then
		self.itemArr:clear();
	end

	local desStr = self.cuiLianConfig[data.refine].Tips_count;
	local nameStr = self:getSuitName(data);
	local curCount = DataCenter.equData:getRefineCount(data, data.refine);
	local totalCount = data.career ~= 0 and 6 or 4;
	self.desTxt.text = "[00E125]" .. string.format(desStr, nameStr, curCount, totalCount);

	local str;
	local len;
	local endStr;
	local strArr = Array();
	local attrDic = self:getAttr(data.refine);
	local jewelryAttrDic = self:getJewelryAttr(data.refine);
	for i = 1, #attrDic do
		len = data.career ~= 0 and #attrDic[i].property or #jewelryAttrDic[i].property;
		str = "";
		for j = 1, len do
			endStr = "";
			if data.career ~= 0 then
				if attrDic[i].tips2_mark[j] == -1 then
					endStr = "%";
				end
				str = str .. attrDic[i].tips2[j] .. attrDic[i].property[j][data.order] .. endStr;
			else
				if jewelryAttrDic[i].tips2_mark[j] == -1 then
					endStr = "%";
				end
				str = str .. jewelryAttrDic[i].tips2[j] .. jewelryAttrDic[i].property[j] .. endStr;
			end

			if j ~= len then
				str = str.."\n";
			end
		end
		strArr:add(str);
	end

	len = data.career ~= 0 and 3 or 2;
	local item;
	local colorStr;
	local preTxt;
	local paramStr;
	self.itemHeight = 0;
	local suitList = DataCenter.equData:getSuitNumList(data.refine, false);
	for i = 1, len do
		if data.career ~= 0 then
			colorStr = suitList[i*2] == data.order and "[FFDF05]" or "[85A8BE]";
		else
			colorStr = curCount >= attrDic[i].count and "[FFDF05]" or "[85A8BE]";
		end
		preTxt = colorStr .. attrDic[i].countShow .. "[-]";
		paramStr = colorStr .. strArr[i] .. "[-]";

		item = Lua_ItemCuiLianItem.new(self.content);
		item:setData(preTxt, paramStr);
		item:setLocation(0, -self.itemHeight - 30, 0);
		self.itemArr:add(item);

		self.itemHeight = self.itemHeight + item:getHeight();
	end
end

function Lua_ItemCuiLianDetail:getHeight()
	return self.itemHeight + 30;
end

function Lua_ItemCuiLianDetail:getSuitName(data)
	local career = data.career == 0 and 4 or DataCenter.roleData.career;
	return getConfig({ "equipment_refine", "refine_name" })[career][data.order];
end

function Lua_ItemCuiLianDetail.Get:cuiLianConfig()
	if self._cuiLianConfig == nil then
		self._cuiLianConfig = getConfig({"equipment_refine", "refine"});
	end
	return self._cuiLianConfig;
end

function Lua_ItemCuiLianDetail:getAttr(refine)
	return self.cuiLianConfig[refine].attr;
end

function Lua_ItemCuiLianDetail:getJewelryAttr(refine)
	return self.cuiLianConfig[refine].jewelry_attr;
end

function Lua_ItemCuiLianDetail:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ItemCuiLianItem = class("Lua_ItemCuiLianItem", Lua_DisplayObject)
function Lua_ItemCuiLianItem:ctor(p)
	self:superCall("ctor", p, "ItemCuiLianItem_skin");
end

function Lua_ItemCuiLianItem:setData(preTxt, des)
	self.countTxt.text = preTxt;
	self.desTxt.text = des;
end

function Lua_ItemCuiLianItem:getHeight()
	return self.desTxt.height;
end