checkRequire("Lua_ItemParam");
Lua_ItemDetailEquBase = class("Lua_ItemDetailEquBase", Lua_DragContainerItem);
function Lua_ItemDetailEquBase:ctor(p)
	self:superCall("ctor", p, "ItemDetailEquBase_skin", false);
end

function Lua_ItemDetailEquBase:setData(val, isYuLan)
	self.data = val;

	self.arr = Array();
	if isYuLan == nil then
		self.isYuLan = false;
	else
		self.isYuLan = isYuLan;
	end

	local checkVal = val;
	if self.isYuLan then
		self.yulan_IntensifyLevel = checkVal.intensifyLevel + 1;
	else
		self.yulan_IntensifyLevel = checkVal.intensifyLevel
	end

	if val.subType == Lua_PackTypeDefine.SPRITE then
		checkVal = val.attribute;
	elseif val.subType == Lua_PackTypeDefine.WING_ITEM then
		if val.wingAttr == nil then
			checkVal = val.attribute;
		else
			checkVal = val.wingAttr;
		end
	end

	local offsetY = -50;
	if checkVal.attack_min ~= 0 and checkVal.attack_max ~= 0 and checkVal.attack_min ~= nil and checkVal.attack_max ~= nil then
		local item = Lua_ItemParam.new(self.content);
		if checkVal.intensifyLevel == nil or checkVal.intensifyLevel == 0 then
			if self.isYuLan == false then
				item:setParam("attack", checkVal.attack_min, checkVal.attack_max, 0);
			else
				item:setParam("attack", checkVal.attack_min, checkVal.attack_max, 
					self:getQiangHuaValue(checkVal.part, "attack", self.yulan_IntensifyLevel));
			end
		else
			item:setParam("attack", checkVal.attack_min, checkVal.attack_max,
				self:getQiangHuaValue(checkVal.part, "attack", self.yulan_IntensifyLevel));
		end
		item:setLocation(-203, offsetY, 0);
		self.arr:add(item);
	end

	local len = #Lua_ThingDefine.params;
	if val.subType == Lua_PackTypeDefine.SHENSHOU_EQU then
		local colorData = DataCenter.sacredAnimalData.configColorData;
		local gm_level = val.gm_level;
		for i = 1, len do
			local v = checkVal[Lua_ThingDefine.params[i]];
			if v ~= 0 and v ~= nil then
				local item = Lua_ItemParam.new(self.content);
				local sval = 0;
				if gm_level ~= nil and gm_level ~= 0 then
					if colorData[val.confingKey][Lua_ThingDefine.params[i]] ~= nil then
						sval = colorData[val.confingKey][Lua_ThingDefine.params[i]][gm_level];
					end
				end
				item:setParam(Lua_ThingDefine.params[i], v, 0, sval);
				item:setLocation(-203, offsetY - 30 * self.arr:getSize(), 0);
				self.arr:add(item);
			end
		end
	elseif val.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
		local colorData = DataCenter.mountEquipUtil.configIntensifyData;
		local intensify_lvl = val.intensify_lvl;
		for i = 1, len do
			local v = checkVal[Lua_ThingDefine.params[i]];
			if v ~= 0 and v ~= nil then
				local item = Lua_ItemParam.new(self.content);
				local sval = 0;
				if intensify_lvl ~= nil and intensify_lvl ~= 0 then
					if colorData[val.id][Lua_ThingDefine.params[i]] ~= nil then
						sval = colorData[val.id][Lua_ThingDefine.params[i]][intensify_lvl];
					end
				end
				item:setParam(Lua_ThingDefine.params[i], v, 0, sval);
				item:setLocation(-203, offsetY - 30 * self.arr:getSize(), 0);
				self.arr:add(item);
			end
		end
	elseif val.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then -- 生肖装备
		for i = 1, len do
			local v = checkVal[Lua_ThingDefine.params[i]];
			if v ~= 0 and v ~= nil then
				local item = Lua_ItemParam.new(self.content);
				local intensifyVal = 0;
				if checkVal.intensifyAttrsDic ~= nil and checkVal.intensifyLevel ~= nil and checkVal.intensifyLevel ~= 0 then
					intensifyVal = val.intensifyAttrsDic[Lua_ThingDefine.params[i]];
				end
				item:setParam(Lua_ThingDefine.params[i], v, 0, intensifyVal);
				item:setLocation(-203, offsetY - 30 * self.arr:getSize(), 0);
				self.arr:add(item);
			end
		end
	else
		for i = 1, len do
			local v = checkVal[Lua_ThingDefine.params[i]];
			if v ~= 0 and v ~= nil then
				local item = Lua_ItemParam.new(self.content);
				if checkVal.intensifyLevel == nil or checkVal.intensifyLevel == 0 then
					if self.isYuLan == false then
						item:setParam(Lua_ThingDefine.params[i], v, 0, 0);
					else
						item:setParam(Lua_ThingDefine.params[i], v, 0,
						self:getQiangHuaValue(checkVal.part, Lua_ThingDefine.params[i], self.yulan_IntensifyLevel));
					end
				else
					item:setParam(Lua_ThingDefine.params[i], v, 0,
					self:getQiangHuaValue(checkVal.part, Lua_ThingDefine.params[i], self.yulan_IntensifyLevel));
				end
				item:setLocation(-203, offsetY - 30 * self.arr:getSize(), 0);
				self.arr:add(item);
			end
		end
	end
end

function Lua_ItemDetailEquBase:getQiangHuaValue(part, attValue, intensifyLevel)
	if self.data.type == Lua_PackTypeDefine.SPRITE_TYPE then
		return 0;
	end
	if self.data.subType == Lua_PackTypeDefine.WING_ITEM then
		return 0;
	end
	if intensifyLevel == nil then
		return 0;
	end
	return getConfig({"equipment_part", "intensify", part, attValue, intensifyLevel});
end

function Lua_ItemDetailEquBase:getHeight()
	return 40 + self.arr:getSize() * 30;
end