-- 分解获得
Lua_ItemDetailResolve = class("Lua_ItemDetailResolve", Lua_DragContainerItem);
function Lua_ItemDetailResolve:ctor(p, isChangePos)
	self:superCall("ctor", p, "ItemDetailResolve_skin");

	if isChangePos then
		self.desBg:setLocation(-213, 0, 0);
		self.desLabel:setLocation(-203, -16, 0);
		self.itemSpr:setLocation(-203, -40, 0);
	end
end

function Lua_ItemDetailResolve:setData(val)
	self.data = val;

	self.scaleValue = 0.5;
	if val.subType == Lua_PackTypeDefine.GATHERSOUL_ITEM then -- 灵魂
		self.itemSpr:setAltas("item6", "201060001");
		self.itemSpr:setSacle(self.scaleValue, self.scaleValue, self.scaleValue);
		self.numTxt.text = val.decompose;
	elseif val.subType == Lua_PackTypeDefine.CARD_ITEM then -- 卡牌
		self.itemSpr:setAltas("wuku_atlas", "ui_wuku_icon_01");
		self.itemSpr:setSacle(self.scaleValue, self.scaleValue, self.scaleValue);
		self.numTxt.text = val.decompose;
	elseif val.subType == Lua_PackTypeDefine.STAMP_ITEM then -- 魂印
		self.itemSpr:setAltas("item15", "201050021");
		self.itemSpr:setSacle(self.scaleValue, self.scaleValue, self.scaleValue);
		self.numTxt.text = val.decompose;
	elseif val.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then -- 军装
		self.itemSpr:setAltas(tostring(val.decomposeItem.atlas), tostring(val.decomposeItem.id));
		self.itemSpr:setSacle(self.scaleValue, self.scaleValue, self.scaleValue);
		self.numTxt.text = val.decompose;
	elseif val.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then -- 生肖装备
		self.itemSpr:setAltas("item18", "217040001");
		self.itemSpr:setSacle(self.scaleValue, self.scaleValue, self.scaleValue);
		local resolveVo = DataCenter.zodiacUtil:getResolveVoById(self.data.id);
		self.numTxt.text = resolveVo.resolveNum;
	end
	self.itemSpr:SetDimensions(76, 76);
	local posX = self.itemSpr.mainContent.transform.localPosition.x + self.itemSpr.width * self.scaleValue + 10;
	local posY = -54 + self.numTxt.height / 2 * self.scaleValue;
	self.numTxt:setLocation(posX, posY, 0);
end

function Lua_ItemDetailResolve:getHeight()
	return self.itemSpr.height * self.scaleValue + 40;
end