﻿Lua_ItemDetailTimeOut = class("Lua_ItemDetailTimeOut", Lua_DragContainerItem);
function Lua_ItemDetailTimeOut:ctor(p, t)
	self.isExpired = false;
	if t == 1 then
		self:superCall("ctor", p, "ItemEquDetailTimeOut_skin");
	else
		self:superCall("ctor", p, "ItemDetailTimeOut_skin");
	end
end

function Lua_ItemDetailTimeOut:buildShowItem()
	self:superCall("buildShowItem");
	self:addTimer("ItemDetailTimeOut", 0.5, self, self.updateTime);
end

function Lua_ItemDetailTimeOut:setData(val)
	self.data = val;
	self:updateTime();
end

function Lua_ItemDetailTimeOut:updateTime()
	if self.data == nil then
		return;
	end

	local isExpired = false;
	if self.data.fairyType ~= nil and self.data.fairyType ~= 0 then
		if self.data.fairyVo.isUsed == 1 then
			local leftTime = self.data.fairyVo.expireTimes - DataCenter.roleData.serverTime;
			if leftTime > 0 then
				self.desLabel.text = LanUtil.formateStr(LanUtil.getValue(110872), TimeTransform.getInstance():transSeconds15(leftTime, true));
			else
				self.desLabel.text = LanUtil.getValue(110873);
				isExpired = true;
			end
		else
			local leftTime = self.data.fairyVo.validTimes;
			self.desLabel.text = LanUtil.formateStr(LanUtil.getValue(110872), TimeTransform.getInstance():transSeconds15(leftTime, true));
		end
	elseif self.data.subType == Lua_PackTypeDefine.NORMAL_GiftPack or self.data.subType == Lua_PackTypeDefine.SELECT_GiftPack or self.data.subType == Lua_PackTypeDefine.CONFIG_GiftPack then
		local leftTime = self.data.timeOut - DataCenter.roleData.serverTime;
		-- print("timeOut", self.data.timeOut, self.data.effective_time);
		if leftTime > 0 then
			if self.data.effective_time ~= nil and self.data.effective_time ~= 0 then
				self.desLabel.text = LanUtil.formateStr(LanUtil.getValue(110876), TimeTransform.getInstance():transSeconds8(self.data.effective_time, LanUtil.getValue(43)), TimeTransform.getInstance():transSeconds8(self.data.timeOut, LanUtil.getValue(43)));
			else
				self.desLabel.text = LanUtil.formateStr(LanUtil.getValue(110872), TimeTransform.getInstance():transSeconds15(leftTime, true));
			end
		else
			self.desLabel.text = LanUtil.getValue(110873);
		end
	else
		local leftTime = self.data.timeOut - DataCenter.roleData.serverTime;
		if leftTime > 0 then
			self.desLabel.text = LanUtil.formateStr(LanUtil.getValue(110872), TimeTransform.getInstance():transSeconds15(leftTime, true));
		else
			self.desLabel.text = LanUtil.getValue(110873);
			isExpired = true;
		end
	end

	if self.isExpired ~= isExpired then
		Lua_MsgUtil.callFunc("UPDATE_EXPIRED_ICON",{isShowExpiredIcon=isExpired});
	end
	self.isExpired = isExpired;
end

function Lua_ItemDetailTimeOut:getHeight()
	return 30;
end