checkRequire("Lua_ItemDetailEquBase");
checkRequire("Lua_ItemGoodParam");
checkRequire("Lua_ItemJewlParam");
checkRequire("Lua_ItemXiLianParam");
checkRequire("Lua_ItemDetailDes");
checkRequire("Lua_ItemDetailOutPut");
checkRequire("Lua_ItemDetailTimeOut");
checkRequire("Lua_ItemCuiLianDetail");
checkRequire("Lua_ItemJewlRefineParam");
checkRequire("Lua_ItemDetailEquZhuLing");
checkRequire("Lua_ItemJueXingBase");
checkRequire("Lua_ItemJueXingStrong");
checkRequire("Lua_ItemJueXingSkill");
checkRequire("Lua_ItemJueXingSuit");
checkRequire("Lua_ItemDetailBeastSoulAttr");
checkRequire("Lua_ItemDetailSpecialAttr");--特殊属性
checkRequire("Lua_ItemDetailResolve"); -- 分解获得
Lua_ItemEquDetail = class("Lua_ItemEquDetail", Lua_DisplayObject);
function Lua_ItemEquDetail:ctor(p)
	self:superCall("ctor", p, "ItemEquDetail_skin");
end

function Lua_ItemEquDetail:buildShowItem()
	self:superCall("buildShowItem");
	
	self.bgStrDic = {
		"ui_common_tips_02_lv",
		"ui_common_tips_02_lan",
		"ui_common_tips_02_zi",
		"ui_common_tips_02_huang",
		"ui_common_tips_02_hong",
		"ui_common_tips_02_fenhong"
	};

	self.img = Lua_ToolImage.new(self.content);
	self.img:setLocation(-150, 180, 0);
	self.img:setCanClick(false);

	self:addLuaEvent("UPDATE_EXPIRED_ICON", self, self.updateCornerMark);
end

-- 更新左上角角标
function Lua_ItemEquDetail:updateCornerMark(param)
	if param ~= nil and param.isShowExpiredIcon == true then
		self.tipObj:SetActive(param.isShowExpiredIcon);
		self.tipTxt.text = LanUtil.getValue(110879);
	else
		if self.data.packType == Lua_PackData.EQU_PACK then
			self.tipObj:SetActive(true);
			self.tipTxt.text = LanUtil.getValue(110880);
		elseif self.data.master_id ~= nil and self.data.subType == Lua_PackTypeDefine.SHENSHOU_EQU then
			self.tipObj:SetActive(true);
			self.tipTxt.text = LanUtil.getValue(110880);
		elseif self.data.mountPart ~= nil and self.data.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
			self.tipObj:SetActive(true);
			self.tipTxt.text = LanUtil.getValue(110880);
		elseif self.data.isWear and self.data.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then
			self.tipObj:SetActive(true);
			self.tipTxt.text = LanUtil.getValue(110880);
		else
			self.tipObj:SetActive(false);
		end
	end
end

function Lua_ItemEquDetail:setData(val, equLvlMark)
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self.data = val;
	self.equLvlMark = equLvlMark == nil and false or equLvlMark;

	self:updateCornerMark();
	self.topBg:setAltas("common_atlas_1", self.bgStrDic[val.color]);
	self.img.data = self.data;
	self.img:showItemBg(true);
	self.img:showNewTip(false);

	if val.subType == Lua_PackTypeDefine.SHENSHOU_EQU then -- 神兽装备
		if self.data.gm_level == nil or self.data.gm_level == 0 then
			self.itemNameTxt.text = self.data.colorNameWithRefine;
		else
			if self.data.gm_level >= self.data.gm_maxLvl then
				self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.. "](MAX)[-]";
			else
				self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."]+"..self.data.gm_level.."[-]";
			end
		end
	elseif val.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then -- 骑装强化
		if self.data.intensify_lvl == nil or self.data.max_intensify_lvl == nil or self.data.intensify_lvl == 0 then
			self.itemNameTxt.text = self.data.colorNameWithRefine;
		else
			if self.data.intensify_lvl >= self.data.max_intensify_lvl then
				self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."](MAX)[-]";
			else
				self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."]+"..self.data.intensify_lvl.."[-]";
			end
		end
	elseif val.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then -- 生肖装备
		if self.data.intensifyLevel == nil or self.data.intensifyLevel == 0  or self.data.intensify_limit == nil then
			self.itemNameTxt.text = self.data.colorNameWithRefine;
		else
			if self.data.intensifyLevel >= self.data.intensify_limit then
				self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."](MAX)[-]";
			else
				self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."]".."+"..self.data.intensifyLevel.."[-]";
			end
		end
	else
		if self.data.intensifyLevel == nil or self.data.intensifyLevel == 0 then
			if self.equLvlMark == true then
				self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."]+"..self.data.intensifyLevel + 1 .."[-]";
			else
				self.itemNameTxt.text = self.data.colorNameWithRefine;
			end
		else
			if self.data.intensifyLevel >= self.data.maxLvl then
				self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."](MAX)[-]";
			else
				if self.equLvlMark == true then
					self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."]+"..self.data.intensifyLevel + 1 .."[-]";
				else
					self.itemNameTxt.text = self.data.colorNameWithRefine.."["..self.data.colorStr.."]+"..self.data.intensifyLevel.."[-]";
				end
			end
		end
	end

	if val.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then -- 生肖装备
		self.fightLabel:setEnable(false);
		self.fightTxt:setEnable(false);
		self.lvLabel:setEnable(false);
		self.lvTxt:setEnable(false);
		self.proLabel:setEnable(false);
		self.proTxt:setEnable(false);
		self.zongLabel:setLocation(-80, 192, 0);
		self.zongTxt:setLocation(35, 192, 0);

		self.zongLabel.text = LanUtil.getValue(143459);
		self.zongTxt.text = tostring(self.data.zongheForce);
		self.careerLabel.text = LanUtil.getValue(143400)..":";
		self.careerTxt.text = "[ED9700]"..DataCenter.zodiacUtil:getZodiacName(val.career).."[-]";
		self.partTxt.text = LanUtil.formateStr(DataCenter.zodiacUtil:getEquipPartName(val.part), val.rtDesc);
		
		self.img:showNum(0, false);
	else
		local roleData = DataCenter.roleData;
		if self.data.profession ~= nil then
			self.proLabel:setEnable(true);
			self.proTxt:setEnable(true);
			
			if self.data.profession == 0 then
				self.proTxt.text = LanUtil.getValue(20);
			else
				local colorStr;
				if roleData.profession >= self.data.profession then
					colorStr = Lua_ColorDefine.WHITE_STR;
				else
					colorStr = Lua_ColorDefine.RED_STR;
				end
				self.proTxt.text = "["..colorStr.."]"..LanUtil.formateStr(LanUtil.getValue(110891), tostring(self.data.profession));
			end
		else
			self.proLabel:setEnable(false);
			self.proTxt:setEnable(false);
		end

		if self.data.useLvl <= roleData.level then
			self.lvTxt.text = self.data.useLvl;
		else
			self.lvTxt.text = "["..Lua_ColorDefine.RED_STR.."]"..self.data.useLvl.."[-]";
		end
		self.fightTxt.text = self.data.score;
		self.zongTxt.text = self.data.zongheForce;

		local jobStr = self.data.career == 0 and LanUtil.getValue(110838) or Lua_ThingDefine.getJobName(self.data.career, self.data.profession);
		if val.subType == Lua_PackTypeDefine.SHENSHOU_EQU or val.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
			self.careerTxt:setEnable(false);
			self.bottomBg:setEnable(false);
			self.careerLabel:setEnable(false);
		else
			self.careerTxt:setEnable(true);
			self.bottomBg:setEnable(true);
			self.careerLabel:setEnable(true);
			if self.data.career == 0 or(roleData.career == self.data.career and roleData.profession >= self.data.profession) then
				self.careerTxt.text = "["..Lua_ColorDefine.YELLOW_STR.."]"..jobStr.."[-]";
			else
				self.careerTxt.text = "["..Lua_ColorDefine.RED_STR.."]"..jobStr.."[-]";
			end
		end

		if val.subType == Lua_PackTypeDefine.SPRITE then
			self.partTxt.text = LanUtil.getValue(110871);
		elseif val.subType == Lua_PackTypeDefine.WING_ITEM then
			self.partTxt.text = LanUtil.getValue(110875);
		elseif val.subType == Lua_PackTypeDefine.SHENSHOU_EQU or val.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then
			self.partLabel:setEnable(false);
			self.partTxt:setEnable(false);
		else
			self.partTxt.text = LanUtil.formateStr(LanUtil.getValue(110850), LanUtil.getValue(self.data.order + 100), Lua_PackUtil.getEquipPart(self.data.part));
		end
	end

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, -170, 435, 340));
	self.dragContainer:setLocation(0, 110, 0);

	if self.data.timeOut ~= nil and self.data.timeOut ~= 0 or self.data.fairyType ~= nil and self.data.fairyType ~= 0 then
		self.timeOut = Lua_ItemDetailTimeOut.new(self.dragContainer.content, 1);
		self.timeOut:setData(self.data);
		self.dragContainer:addSubContainer(self.timeOut, false);
	end

	self.i1 = Lua_ItemDetailEquBase.new(self.dragContainer.content);
	self.i1:setData(self.data, self.equLvlMark);
	self.dragContainer:addSubContainer(self.i1, false);

	if self.data.subType ~= Lua_PackTypeDefine.WING_ITEM
		and self.data.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE
		and ((self.data.equipment ~= nil
		and self.data.equipment.attr ~= nil
		and #self.data.equipment.attr > 0)
		or self.data.legend ~= nil) then
		
		self.i2 = Lua_ItemGoodParam.new(self.dragContainer.content);
		self.i2:setData(self.data);
		self.dragContainer:addSubContainer(self.i2, false);
	end

	if self.data.subType == Lua_PackTypeDefine.EQUIP then -- 装备注灵属性   
		local limitArr = Lua_ZhuLingUtil.getLimit(self.data.part)
		if self.data.order >= limitArr[1] and self.data.star >= limitArr[2] and self.data.color >= limitArr[3] then
			self.zhulingItem = Lua_ItemDetailEquZhuLing.new(self.dragContainer.content);
			self.zhulingItem:setData(self.data);
			self.dragContainer:addSubContainer(self.zhulingItem, false);
		end
	end

	if self.data.subType == Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then -- 骑装属相显示
		if (self.data.packType == Lua_PackData.BAG_PACK
			or self.data.packType == Lua_PackData.WHARE
			or self.data.mountPart ~= nil
			or self.data.packType == Lua_PackTypeDefine.EQUIP
			or self.data.packType == 999)
			and self.data.equipment ~= nil
			and self.data.equipment.attr ~= nil
			and #self.data.equipment.attr > 0 then
			
			self.i2 = Lua_ItemGoodParam.new(self.dragContainer.content);
			self.i2:setData(self.data);
			self.dragContainer:addSubContainer(self.i2, false);
		elseif self.data.packType ~= Lua_PackData.BAG_PACK and self.data.mountPart == nil
			and self.data.packType ~= Lua_PackTypeDefine.EQUIP
			and self.data.packType ~= 999
			and self.data.legend ~= nil
			and self.data.packType ~= Lua_PackData.WHARE then
			
			self.i2 = Lua_ItemGoodParam.new(self.dragContainer.content);
			self.i2:setData(self.data);
			self.dragContainer:addSubContainer(self.i2, false);
		end
	end

	if self.data.jewel ~= nil
		and self.data.subType ~= Lua_PackTypeDefine.SHENSHOU_EQU
		and self.data.subType ~= Lua_PackTypeDefine.MOUNT_EQUIP_TYPE then -- 根据策划需求屏蔽骑装Tips宝石属性

		self.i3 = Lua_ItemJewlParam.new(self.dragContainer.content);
		self.i3:setData(self.data);
		self.dragContainer:addSubContainer(self.i3, false);
	end

	if self.data.jewel ~= nil
		and self.data.jewl_Level ~= 0
		and self.data.jewl_Level ~= nil
		and self.data.subType ~= Lua_PackTypeDefine.SHENSHOU_EQU then
		
		self.refineItem = Lua_ItemJewlRefineParam.new(self.dragContainer.content);
		self.refineItem:setData(self.data);
		self.dragContainer:addSubContainer(self.refineItem, false);
	end

	local _arr = self.data.wash_attrs;
	if _arr ~= nil then
		for i = 1, #_arr do
			if _arr[i].open == true and _arr[i].attr.attr_id ~= 0 then
				self.i4 = Lua_ItemXiLianParam.new(self.dragContainer.content);
				self.i4:setData(self.data);
				self.dragContainer:addSubContainer(self.i4, false);
				break;
			end
		end
	end

	-- 淬炼级别：0未淬炼，1史诗，2传说
	if self.data.refine ~= nil and self.data.refine ~= 0 then
		self.i5 = Lua_ItemCuiLianDetail.new(self.dragContainer.content);
		self.i5:setData(self.data);
		self.dragContainer:addSubContainer(self.i5, false);
	end

	if self.data.awake_level ~= nil and self.data.awake_level ~= 0 then
		self.i6 = Lua_ItemJueXingBase.new(self.dragContainer.content);
		self.i6:setData(self.data);
		self.dragContainer:addSubContainer(self.i6, false);

		if self.data.intensifyLevel ~= nil and self.data.intensifyLevel ~= 0 then
			self.i7 = Lua_ItemJueXingStrong.new(self.dragContainer.content);
			self.i7:setData(self.data);
			self.dragContainer:addSubContainer(self.i7, false);
		end
	end

	if self.data.spirit_level ~= 0 and self.data.spirit_level ~= nil then
		self.i8 = Lua_ItemJueXingSkill.new(self.dragContainer.content);
		self.i8:setData(self.data);
		self.dragContainer:addSubContainer(self.i8, false);
	end

	if self.data.subType == Lua_PackTypeDefine.SPRITE or self.data.subType == Lua_PackTypeDefine.WING_ITEM then
		self.idd = Lua_ItemDetailDes.new(self.dragContainer.content, 1);
		self.idd:setData(self.data);
		self.dragContainer:addSubContainer(self.idd, false);

		self.idop = Lua_ItemDetailOutPut.new(self.dragContainer.content, 1);
		self.idop:setData(self.data);
		self.dragContainer:addSubContainer(self.idop, true);
	end

	if self.data.subType == Lua_PackTypeDefine.ZODIAC_EQUIP_ITEM then
		if self.data.isWear == true and self.data.equipment ~= nil and self.data.equipment.zodiac_attr ~= nil then
			local beastSoul = Lua_ItemDetailBeastSoulAttr.new(self.dragContainer.content);
			beastSoul:setData(self.data);
			self.dragContainer:addSubContainer(beastSoul, false);
		end

		local iSpecial = Lua_ItemDetailSpecialAttr.new(self.dragContainer.content);
		iSpecial:setData(self.data);
		self.dragContainer:addSubContainer(iSpecial, false);

		local iResolve = Lua_ItemDetailResolve.new(self.dragContainer.content);
		iResolve:setData(self.data);
		self.dragContainer:addSubContainer(iResolve, false);
	end
	self.dragContainer:updateChildPos();
end

function Lua_ItemEquDetail:showHideLeagueScore(val, donate)
	if val == true then
		local leagueScore = self.data.leagueScore == nil and 0 or self.data.leagueScore;
		local leagueBuyScore = self.data.leagueBuyScore == nil and 0 or self.data.leagueBuyScore;
		self.factionScoreTxt.text = donate == true and tostring(leagueScore) or tostring(leagueBuyScore);
		
		self.dragContainer:updateClipRegion(Vector4(0, -167, 435, 335));
		self.bottomBg:SetDimensions(419, 76);
		
		self.factionScoreLb:setEnable(true);
		self.factionScoreLb.text = donate == true and LanUtil.getValue(121044) or LanUtil.getValue(121045);
		self.factionScoreTxt:setEnable(true);
		self.factionScoreIcon:setEnable(true);
	else
		self.factionScoreTxt.text = "0";
		self.dragContainer:updateClipRegion(Vector4(0, -170, 435, 340));
		self.bottomBg:SetDimensions(419, 37);
		self.factionScoreLb:setEnable(false);
		self.factionScoreTxt:setEnable(false);
		self.factionScoreIcon:setEnable(false);
	end
end