-- tips显示的道具信息
checkRequire("Lua_NumberInputItem");
checkRequire("Lua_ItemDetailDes");
checkRequire("Lua_ItemDetailOutPut");
checkRequire("Lua_ItemDetailTimeOut");
checkRequire("Lua_ItemDetailSoulProp");
checkRequire("Lua_ItemDetailResolve");
checkRequire("Lua_ItemDetailSpecialAttr"); -- 特殊属性
checkRequire("Lua_ItemDetailSuitAttr"); --套装属性
checkRequire("Lua_ItemlDetailSkillName"); -- 组合技能(卡牌)
checkRequire("Lua_ItemlDetailGroupProp"); -- 组合属性(卡牌)
checkRequire("Lua_ItemGoodParam"); -- 极品属性
Lua_ItemShowPanel = class("Lua_ItemShowPanel", Lua_DisplayObject);
function Lua_ItemShowPanel:ctor(p, t)
	-- print("Lua_ItemShowPanel", t);
	if t == 1 then -- t 卡牌属性
		self:superCall("ctor", p, "ItemDetailBasicsWindow_skin"); -- 卡牌道具用自己独立Tips
	elseif t == 2 then
		self:superCall("ctor", p, "ItemDetailStampWindow_skin"); -- 魂印道具用自己独立Tips
	elseif t == 3 then
		self:superCall("ctor", p, "ItemDetailAemyWindow_skin");  -- 军装道具用自己独立Tips
	else
		self:superCall("ctor", p, "ItemDetailWindow_skin"); -- 通用道具Tips
	end
end

function Lua_ItemShowPanel:dispose()
	self:superCall("dispose");
end

function Lua_ItemShowPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_ItemShowPanel";

	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onBgClick);

	self.img = Lua_ToolImage.new(self.content);
	self.img:setLocation(-115, 140, 0);
	self.img:setCanClick(false);

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, -155, 348, 310));
	self.dragContainer:setLocation(0, 80, 0);
	self.dragContainer:setEnable(true);

	self.bgStrDic = {"ui_common_tips_02_lv", "ui_common_tips_02_lan", "ui_common_tips_02_zi",
		"ui_common_tips_02_huang", "ui_common_tips_02_hong", "ui_common_tips_02_fenhong"};
end

function Lua_ItemShowPanel:onBgClick(go)
end

function Lua_ItemShowPanel:setShowData(obj)
	if obj == nil then
		return;
	end

	self.data = obj.data;
	self.isMarketSell = obj.isMarketSell;
	self.isShowBtns = obj.isShowBtns;

	self.img.data = self.data;
	self.img:showItemBg(true);
	self.img:showNewTip(false);--隐藏道具Tips New UI标识
	self.img:showNumFromNumberOne(0, false);

	self.topBg:setAltas("common_atlas_1", self.bgStrDic[self.data.color]);

	if self.dragContainer.childrenList:getSize() > 0 then
		self.dragContainer.childrenList:clear();
	end

	if self.data.effect_prop.use_limit_num ~= nil and self.data.effect_prop.use_limit_num ~= 0 then
		if self.use_times_desLbl == nil then
			self.use_times_desLbl = UICreate.createLabel(self.content, "", 0, 0, 71, 30, 22);
			self.use_times_desLbl.overflowMethod = UILabel.Overflow.ResizeFreely;
			self.use_times_desLbl.pivot = UIWidget.Pivot.Left;
			self.use_times_desLbl:setLocation(-120, -200, 0);
			self.use_times_desLbl:setEnable(true);
			self.use_times_desLbl.effectColorStr = "2986344448";
			self.use_times_desLbl.effectStyle = 0;
			self.use_times_desLbl:setEffectDistance(1, 1);
			self.use_times_desLbl:setDepth(self.depth + 10);

			if self.data.useTimes ~= nil and self.data.effect_prop.use_limit_num - self.data.useTimes > 0 then
				self.use_times_desLbl.text = LanUtil.formateStr(LanUtil.getValue(123806), tostring(self.data.effect_prop.use_limit_num - self.data.useTimes), tostring(self.data.effect_prop.use_limit_num))
			else
				self.use_times_desLbl.text = LanUtil.formateStr(LanUtil.getValue(123807), tostring(self.data.effect_prop.use_limit_num - self.data.useTimes), tostring(self.data.effect_prop.use_limit_num))
			end
		end
	end

	-- 军装
	if self.data.type == 13 and self.data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then
		self.img:setLocation(-150, -80, 0);
		-- self.img:showStampEff(true);
		self.img:showBetterTip(0);

		self.putSp:SetActive(self.data.army_part ~= nil);

		local intensify_lvl = self.data.intensify_lvl == nil and 0 or self.data.intensify_lvl;
		self.name.text = self.data.colorNameWithRefine;
		self.partLab.text = LanUtil.formateStr(LanUtil.getValue(128518), tostring(self.data.part_name)); -- 位置
		self.lvLab.text = LanUtil.formateStr(LanUtil.getValue(140522), tostring(intensify_lvl)); -- 等级
		self.soulLab.text = LanUtil.formateStr(LanUtil.getValue(140523), tostring(self.data.army_name)); -- 军魂
		self.placeLab.text = LanUtil.getValue(140524); -- 描述
		self.maxLvLab.text = LanUtil.formateStr(LanUtil.getValue(140525), tostring(self.data.max_intensify_lvl)); -- 最大强化等级

		self.dragContainer:updateClipRegion(Vector4(0, -160, 430, 320));
		self.dragContainer:setLocation(0, -150, 0);
		-- 基础属性
		if self.i1 == nil then
			self.i1 = Lua_ItemDetailSoulProp.new(self.dragContainer.content, true);
		end
		self.i1:setData(self.data);
		self.dragContainer:addSubContainer(self.i1, true);

		-- 分解属性
		if self.i3 == nil then
			self.i3 = Lua_ItemDetailResolve.new(self.dragContainer.content, true);
		end
		self.i3:setData(self.data);
		self.dragContainer:addSubContainer(self.i3, true);

		--描述产出地
		if self.outPut == nil then
			self.outPut = Lua_ItemDetailOutPut.new(self.dragContainer.content, 1);
		end
		self.outPut:setData(self.data);
		self.dragContainer:addSubContainer(self.outPut, true);
	end

	-- 魂印
	if self.data.type == 12 and self.data.subType == Lua_PackTypeDefine.STAMP_ITEM and self.data.stamp_type ~= 0 then
		self.img:setLocation(-150, 180, 0);
		self.img:showStampEff(true);
		self.img:showBetterTip(0);

		self.putSp:SetActive(self.data.stamp_part ~= nil);

		if self.data.intensify_lvl == nil or self.data.max_intensify_lvl == nil or self.data.intensify_lvl == 0 then
			self.name.text = self.data.colorNameWithRefine;
		else
			if self.data.intensify_lvl >= self.data.max_intensify_lvl then
				self.name.text = self.data.colorNameWithRefine.. "[" ..self.data.colorStr.. "](MAX)" .. "[-]";
			else
				self.name.text = self.data.colorNameWithRefine.. "[" ..self.data.colorStr.. "]+" ..self.data.intensify_lvl .. "[-]";
			end
		end
		self.partLab.text = LanUtil.formateStr(LanUtil.getValue(128518),tostring(self.data.part_name)); -- 位置
		self.fightLab.text = LanUtil.formateStr(LanUtil.getValue(128519),tostring(self.data.force)); -- 战力
		self.lvl_txt.text = LanUtil.formateStr(LanUtil.getValue(128520),tostring(self.data.useLvl)); -- 穿戴等级
		self.typeLab.text = LanUtil.formateStr(LanUtil.getValue(128521),tostring(self.data.stamp_part_Type));  -- 类型
		self.orderLab.text = LanUtil.formateStr(LanUtil.getValue(128522),LanUtil.getValue(self.data.order + 100));  -- 阶级

		self.dragContainer:updateClipRegion(Vector4(0, -170, 430, 340));
		self.dragContainer:setLocation(0, 110, 0);
		if self.data.stamp_type ~= 0 then
			-- 基础属性
			if self.i1 == nil then
				self.i1 = Lua_ItemDetailSoulProp.new(self.dragContainer.content, true);
			end
			self.i1:setData(self.data);
			self.dragContainer:addSubContainer(self.i1, true);
		else
			if self.des == nil then
				self.des = Lua_ItemDetailDes.new(self.dragContainer.content);
			end
			self.des:setData(self.data);
			self.dragContainer:addSubContainer(self.des, false);
		end

		-- 极品属性
		if self.data.stampGoodProp ~= nil then
			if self.i2 == nil then
				self.i2 = Lua_ItemGoodParam.new(self.dragContainer.content);
			end
			self.i2:setData(self.data);
			self.dragContainer:addSubContainer(self.i2, false);
		else
			if self.i2 ~= nil then
				self.i2:dispose();
				self.i2 = nil;
			end
		end

		-- 特殊属性
		if self.data.stampSpecialAttr ~= nil then
			if self.i4 == nil then
				self.i4 = Lua_ItemDetailSpecialAttr.new(self.dragContainer.content);
			end
			self.i4:setData(self.data);
			self.dragContainer:addSubContainer(self.i4, true);
		else
			if self.i4 ~= nil then
				self.i4:dispose();
				self.i4 = nil;
			end
		end

		-- 分解属性
		if self.i3 == nil then
			self.i3 = Lua_ItemDetailResolve.new(self.dragContainer.content, true);
		end
		self.i3:setData(self.data);
		self.dragContainer:addSubContainer(self.i3, true);

		if self.data.isShowItemSuit ~= nil then
		-- 套装属性
			if self.i5 == nil then
				self.i5 = Lua_ItemDetailSuitAttr.new(self.dragContainer.content);   
			end
			self.i5:setData(self.data);
			self.dragContainer:addSubContainer(self.i5, false);
		else
			if self.i5 ~= nil then
				self.i5:dispose();
				self.i5 = nil;
			end
		end

		--描述产出地
		if self.outPut == nil then
			self.outPut = Lua_ItemDetailOutPut.new(self.dragContainer.content, 1);
		end
		self.outPut:setData(self.data);
		self.dragContainer:addSubContainer(self.outPut, true);
	end

	-- 卡牌
	if self.data.type == 11 and self.data.subType == Lua_PackTypeDefine.CARD_ITEM then
		self.img:setLocation(-99, 143, 0);
		self.img.item_bg:SetDimensions(66, 66);
		self.img.item_img:SetDimensions(66, 66);
		self.img.gm_Lvl_Txt.fontSize = 16;
		self.img.gm_Lvl_Txt:setLocation(33, 19);

		self.putSp:setEnable(self.data.cardPart ~= nil);
		self.isWear:setEnable(self.data.cardPart ~= nil);

		if self.data.card_level == nil then
			self.data.card_level = 0;
		end

		self.name.text = self.data.colorName; -- 灵魂名字
		self.part_txt.text = self.data.cord_location; -- 灵魂位置
		self.lvl_txt.text = LanUtil.formateStr(LanUtil.getValue(124435), tostring(self.data.card_level));

		self.dragContainer:updateClipRegion(Vector4(0, -150, 335, 300));
		self.dragContainer:setLocation(3, 90, 0);
		if self.data.card_type ~= 0 then
			-- 基础属性
			if self.i1 == nil then
				self.i1 = Lua_ItemDetailSoulProp.new(self.dragContainer.content);
			end 
			self.i1:setData(self.data);
			self.dragContainer:addSubContainer(self.i1, false);
		else
			if self.des == nil then
				self.des = Lua_ItemDetailDes.new(self.dragContainer.content);
			end  
			self.des:setData(self.data);
			self.dragContainer:addSubContainer(self.des, false);
		end

		-- 极品属性
		if self.data.equipment ~= nil and self.data.equipment.attr ~= nil and #self.data.equipment.attr > 0 then
			if self.i2 == nil then
				self.i2 = Lua_ItemGoodParam.new(self.dragContainer.content, true);
			end
			self.i2:setData(self.data);
			self.dragContainer:addSubContainer(self.i2, false);
		else
			if self.i2 ~= nil then
				self.i2:dispose();
				self.i2 = nil;
			end
		end

		-- 分解属性
		if self.i3 == nil then
			self.i3 = Lua_ItemDetailResolve.new(self.dragContainer.content);
		end
		self.i3:setData(self.data);
		self.dragContainer:addSubContainer(self.i3, true);

		if self.data.isShowGroup == true then
			-- 组合技能
			if self.i4 == nil then
				self.i4 = Lua_ItemlDetailSkillName.new(self.dragContainer.content);
			end
			self.i4:setData(self.data);
			self.dragContainer:addSubContainer(self.i4, false);

			-- 组合属性
			if self.i5 == nil then
				self.i5 = Lua_ItemlDetailGroupProp.new(self.dragContainer.content);
			end
			self.i5:setData(self.data);
			self.dragContainer:addSubContainer(self.i5, false);
		else
			if self.i4 ~= nil then
				self.i4:dispose();
				self.i4 = nil;
			end

			if self.i5 ~= nil then
				self.i5:dispose();
				self.i5 = nil
			end
		end

		-- 描述产出地
		if self.outPut == nil then
			self.outPut = Lua_ItemDetailOutPut.new(self.dragContainer.content);
		end
		self.outPut:setData(self.data);
		self.dragContainer:addSubContainer(self.outPut, true);
	end

	-- 灵魂
	if self.data.type == 8 and self.data.subType == Lua_PackTypeDefine.GATHERSOUL_ITEM then
		-- self.content.transform.localPosition = Vector3(162, 0, 0);
		LuaUtil.setObjPos(self.content, 162, 0, 0);

		self.tipsObj:SetActive(self.data.groove_id ~= nil);
		self.soulItemObj:SetActive(true); -- 聚魂属性
		self.itemObj:SetActive(false);
		
		self.img:setLocation(-106, 110, 0);

		if self.data.soul_level == nil then
			self.data.soul_level = 0;
		end
		self.soul_name.text = self.data.soulName; -- 灵魂名字
		self.location_txt.text = self.data.soul_location; -- 灵魂位置
		self.lvl_txt.text = LanUtil.formateStr(LanUtil.getValue(124435),tostring(self.data.soul_level + 1)); -- 灵魂等级

		self.dragContainer:updateClipRegion(Vector4(0, -134, 336, 268));
		self.dragContainer:setLocation(0, 50, 0);
		if self.data.soul_type ~= 2 then
			if self.prop == nil then
				self.prop = Lua_ItemDetailSoulProp.new(self.dragContainer.content);
			end
			self.prop:setData(self.data);
			self.dragContainer:addSubContainer(self.prop, true);      

			if self.data.prop_type == 1 then
				if self.resolve == nil then
					self.resolve = Lua_ItemDetailResolve.new(self.dragContainer.content);
				end
				self.resolve:setData(self.data);
				self.dragContainer:addSubContainer(self.resolve, true);
			else
				if self.resolve ~= nil then
					self.resolve:dispose();
					self.resolve = nil;
				end
			end
		else
			if self.des == nil then
				self.des = Lua_ItemDetailDes.new(self.dragContainer.content);
			end
			self.des:setData(self.data);
			self.dragContainer:addSubContainer(self.des, false);

			if self.resolve1 == nil then
				self.resolve1 = Lua_ItemDetailResolve.new(self.dragContainer.content);
			end
			self.resolve1:setData(self.data);
			self.dragContainer:addSubContainer(self.resolve1, true);
		end

		if self.outPut == nil then
			self.outPut = Lua_ItemDetailOutPut.new(self.dragContainer.content);
		end
		self.outPut:setData(self.data);
		self.dragContainer:addSubContainer(self.outPut, true);
	end

	-- 下列为通用Tips
	if self.data.subType ~= Lua_PackTypeDefine.GATHERSOUL_ITEM and self.bottomBg ~= nil then -- 屏蔽聚魂
		-- self.content.transform.localPosition = Vector3(0, 0, 0);
		LuaUtil.setObjPos(self.content, 0, 0, 0);
		
		self.tipsObj:SetActive(false)
		self.soulItemObj:SetActive(false);
		self.itemObj:SetActive(true);

		self.itemNameTxt.text = self.data.colorName;
		self.lvLabel.text = LanUtil.getValue(126028);

		if self.data.subType == Lua_PackTypeDefine.UNREAL_CHIP then -- 幻化碎片
			self.lvLabel.text = LanUtil.formateStr(LanUtil.getValue(126027),tostring(self.data.order));
			self.lvTxt.text = "";
		elseif self.data.subType == Lua_PackTypeDefine.LIFE_LINGWEN then -- 灵纹
			if self.data.rune_level ~= nil then
				self.lvTxt.text = self.data.rune_level;
			else
				self.lvTxt.text = tostring(self.data.useLvl);
			end
		else
			self.lvTxt.text = tostring(self.data.useLvl);
		end

		if self.data.timeOut ~= nil and self.data.timeOut ~= 0 then
			if self.timeOut == nil then
				self.timeOut = Lua_ItemDetailTimeOut.new(self.dragContainer.content);
			end
			self.timeOut:setData(self.data);
			self.dragContainer:addSubContainer(self.timeOut, false);
		else
			if self.timeOut ~= nil then
				self.dragContainer:removeSubContainer(self.timeOut, false);
				self.timeOut:dispose();
				self.timeOut = nil;
			end
		end

		if self.i2 == nil then
			self.i2 = Lua_ItemDetailDes.new(self.dragContainer.content);
		end
		self.i2:setData(self.data);
		self.dragContainer:addSubContainer(self.i2, false);

		if self.data.subType == Lua_PackTypeDefine.STAMP_ITEM and self.data.stamp_type == 0 then -- 分解属性
			if self.i5 == nil then
				self.i5 = Lua_ItemDetailResolve.new(self.dragContainer.content);
			end
			self.i5:setData(self.data);
			self.dragContainer:addSubContainer(self.i5, true);
		end
		
		if self.i3 == nil then
			self.i3 = Lua_ItemDetailOutPut.new(self.dragContainer.content);
		end
		self.i3:setData(self.data);
		self.dragContainer:addSubContainer(self.i3, true);
	end

	local oo;
	if self.isMarketSell == true then -- 市场上架
		oo = Lua_PackUtil.showMarketSellDetail(self.data);
	elseif DataCenter.packData.showWharePanel == false or (self.data.type == 8 and self.data.subType == Lua_PackTypeDefine.GATHERSOUL_ITEM) then
		oo = Lua_PackUtil.showNormalDetail(self.data);
	else
		oo = Lua_PackUtil.showWhareDetail(self.data);
	end
	self.actList = oo[2];

	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end

	if self.isShowBtns == true then
		local btnNames = oo[1];
		if btnNames ~= nil and btnNames:getSize() > 0 then
			self.btnList = Lua_ButtonList.new(self.content, btnNames, 57, self, self.onButtonListClick,
				"ui_common_btn_x9", "ui_common_btn_x8", Vector4(0, 0, 120, 42), Vector4(0, 0, 120, 42),
				Lua_ColorDefine.transColor("B7E8FF"), Lua_ColorDefine.transColor("FFFCB7"), Vector4(22, 22, 120, 30), 
				1, "common_atlas_1", Vector3(0, 0, 0), Vector3(0, 0, 0));
			self.btnList:setLocation(245, -219 + 57 *(btnNames:getSize() - 1), 0);
		end

		-- 军装
		if self.data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then
			if self.data.packType == Lua_PackData.ARMY_PACK or self.data.army_part ~= nil then
				self.btnList:setLocation(253, -539 + 57 * (btnNames:getSize() - 1), 0);
				self.btnList:setRedDotPos(55, 16);
				if self.data.isShowItemReplaceRed == true then
					self.btnList:setRedDotStateByIndex(1, true);
				end

				if self.data.army_part ~= nil then
					if self.data.isShowIntensifyRed == true then
						self.btnList:setRedDotStateByIndex(2, true);
					end
				else
					if self.data.isSameType == true then
						self.btnList:setRedDotStateByIndex(1, true);
					end

					if DataCenter.armySoulData.isSelectPack == true then
						self.btnList:setRedDotStateByIndex(1, false);
					end
				end
			end
		end

		-- 魂印
		if self.data.subType == Lua_PackTypeDefine.STAMP_ITEM and self.data.stamp_type ~= 0 then
			if self.data.packType == Lua_PackData.STAMP_PACK or self.data.stamp_part ~= nil then
				self.btnList:setLocation(285, -263 + 57 * (btnNames:getSize() - 1), 0);
				if self.data.packType == Lua_PackData.STAMP_PACK then
					if self.data.isShowItemReplaceRed == true then
						self.btnList:setRedDotPos(55, 16);
						self.btnList:setRedDotStateByIndex(1,true);
					end
				end
			end
		end

		-- 卡牌
		if self.data.subType == Lua_PackTypeDefine.CARD_ITEM then
			if self.data.packType == Lua_PackData.CARD_PACK or self.data.cardPart ~= nil then
				self.btnList:setLocation(240, -190 + 57 * (btnNames:getSize() - 1), 0);
				if self.data.cardPart ~= nil then
					self.btnList:setRedDotPos(55, 16);
					local data = DataCenter.cardData:getArrByCardInfo(self.data.cardPart);
					if data:isShowCardUpgradeRed() == true then
						self.btnList:setRedDotStateByIndex(1,true);
					end
				end
			end
		end

		-- 灵魂
		if self.data.subType == Lua_PackTypeDefine.GATHERSOUL_ITEM and self.data.packType ~= 999 and self.data.packType ~= 200 then
			if self.data.groove_id ~= nil and self.data.packType ~= Lua_PackData.JH_PACK then 
				self.btnList:setRedDotPos(55, 16);
				local soulVo = DataCenter.gatherSoulData:getArrByGrooveId(self.data.groove_id).soulVo;
				local isMsxLvl = DataCenter.gatherSoulUtil:isMsxLvl(soulVo.soulColor,soulVo.soul_level); -- 是否满级
				if isMsxLvl == false then
					if soulVo.soulUpgrade ~= nil and DataCenter.gatherSoulData.soulDust >= soulVo.soulUpgrade then
						if soulVo.prop_type == 1 then -- 单属性
							self.btnList:setRedDotStateByIndex(1, true);
						else
							self.btnList:setRedDotStateByIndex(2, true);
						end
					end
				end
			elseif self.data.packType == Lua_PackData.JH_PACK and self.data.soul_type ~= 2 then
				self.btnList:setRedDotPos(55, 16);
				if self.data.isShowDressRed == true then
					self.btnList:setRedDotStateByIndex(1,true);
				end
			end
		end
	end

	-- 有捐献，要显示帮派捐献积分
	if self.actList:indexOf(10) ~= -1 then
		if self.data.leagueBuyScore ~= nil then
			self:onSetNumCallBack(1);
		end

		if self.numberInput == nil then
			self.numberInput = Lua_NumberInputItem.new(self.content);
			self.numberInput:setLocation(0, -200, 0);
			self.numberInput:setAddTen(false);
			self.numberInput:setWindowOffset(302, -33);
			self.numberInput:setMinMaxValue(1, self.data.count);
			self.numberInput:setNum(1);
			self.numberInput:setNumCallBack(self, self.onSetNumCallBack);
			self.numberInput.numBg:SetDimensions(200, 32)
			self.numberInput.subSp:setLocation(-126, 0)
			self.numberInput.addSp:setLocation(126, 0)
			self.numberInput.add10SpTxt:setEnable(false)
		end
		self.numberInput:setMinMaxValue(1, self.data.count);
		
		self.dragContainer:updateClipRegion(Vector4(0, -99, 335, 198));
	else
		if self.bottomBg ~= nil then
			self.bottomBg:setEnable(false);
			self.factionScoreLb:setEnable(false);
			self.factionScoreIcon:setEnable(false);
			self.factionScoreTxt:setEnable(false);
			self.countTxt:setEnable(false);
		end

		if self.numberInput ~= nil then
			self.numberInput:dispose();
			self.numberInput = nil;
		end
	end
end

function Lua_ItemShowPanel:onSetNumCallBack(val)
	local needScore = self.data.leagueBuyScore * val;
	local colorStr = DataCenter.factionData.myFactionInfo.deportScore >= needScore and "[FFFFFF]" or "[FF1616]";
	self.factionScoreTxt.text = colorStr .. needScore .. "[-]";
end

function Lua_ItemShowPanel:onButtonListClick(val)
	local rtData = DataCenter.allRtData.topRightIconDic[10098];
	if val == 1 and tonumber(self.data.id) == 201030030 and (rtData == nil or rtData.canShow == false) then
		Lua_WindowUtil.openWin("Lua_ItemDetailWindow", WinParam.ACTION_CLOSE);
		OperateAlert.show(LanUtil.getValue(122586))
		return;
	end

	local actVal = self.actList[val];
	if actVal ~= nil then
		local tnum = self.data.count;
		if self.numberInput ~= nil then
			tnum = self.numberInput.num;
		end

		if (self.data.type == 8 and self.data.subType == Lua_PackTypeDefine.GATHERSOUL_ITEM)
			or self.data.type == Lua_PackTypeDefine.TREASURE_ACT_TYPE
			or self.data.type == Lua_PackTypeDefine.GSBACKGIFT_TYPE
			or self.data.subType == Lua_PackTypeDefine.CARD_ITEM
			or self.data.subType == Lua_PackTypeDefine.STAMP_ITEM then
				Lua_PackUtil.doActClick(actVal, self.data)
		else
			local tvo = Lua_ToolVo.createToolVo(self.data.id, tnum, self.data.bind);
			tvo.index = self.data.index;
			tvo.packType=self.data.packType;
			Lua_PackUtil.doActClick(actVal, tvo)
		end
	end
	Lua_WindowUtil.openWin("Lua_ItemDetailWindow", WinParam.ACTION_CLOSE);
end